#!/usr/bin/python3 -u

import os
import sys
import time
import struct
import serial
from subprocess import Popen, PIPE, run

f = open("subprocess.log", "w+")

ser = serial.Serial('/dev/ttyUSB0', 115200)

def flash():
        run("JLinkExe flash.jlink", shell=True, check=True)

def read(channel, l):
    if channel == 'ser':
        data = ser.read(l)
    elif channel == 'std':
        data = sys.stdin.buffer.read(l)
    else:
        raise Exception("read() complains: no sai channelino")
#    if channel == "std" and len(data) == 0:
#        sys.exit(0)
    if len(data) != l:
        raise Exception("could not read %d bytes of data (got %d)" % (l, len(data)))
    return data

def write(channel, data):
    if channel == 'ser':
        l = ser.write(data)
        f.write("Data sent to serial: " + str(data) + "\n")
    elif channel == 'std':
        l = sys.stdout.buffer.write(data)
    else:
        raise Exception("write() complains: no sai channelino")
    if len(data) != l:
        raise Exception("could not write %d bytes of data (put %d)" % (len(data), l))
            
def obtain(channel):
    l = read(channel, 4)
    (l, ) = struct.unpack("<I", l)
    f.write("Trying to read %d bytes from %s\n" % (l, channel))
    return read(channel, l)

def submit(channel, action, data):
    if channel == "std":
        h = struct.pack("<I", len(data))
    else:
        h = struct.pack("<BI", ord(action), len(data))
    write(channel, h)
    write(channel, data)
    time.sleep(0.1)

def main():
    #flash()
    print("Hello, World!")
    while(1):
        action = read('std', 1)
        f.write("Read following action from stdin: %s\n" % action)
        if action == b'c' or action == b'm' or action == b'a' or action == b'k' or action == b's' or action == b'p':
            data = obtain('std')
            submit('ser', action, data)

        elif action == b'e' or action == b'd':
            write('ser', action)

        elif action == b'C' or action == b'M' or action == b'A' or action == b'K' or action == b'S' or action == b'P':
            write('ser', action)
            data = obtain('ser')
            f.write("Obtained following data from serial: %s\n" % data)
            submit('std', action, data)
            f.write("Submitted following data to stdout: %s\n" % data)
        else:
            raise Exception("no capiche aczione %s" % (action))
                
if __name__ == "__main__":
    sys.exit(main())
